<template>
  <div class="gpa-diff-entry__line" :class="syncable ? '' : '-text--color-mute small'">
    <pre class="-text--right">{{ trusted }}</pre>
    <div class="-text--center">{{ field }}</div>
    <div>
      <rui-button v-if="syncable"
                  variant="recording"
                  :disabled="disabled"
                  :title="$t('js.admin.import.sync_field')"
                  icon="caret-double-right"
                  @click="$emit('sync')" />
    </div>
    <pre :class="message? 'text--color-warning' : ''">{{ message || current }}</pre>
  </div>
</template>

<script>
import isEqual from 'lodash.isequal'

import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'

export default {
  name: 'GpaDiffLine',
  emits: [
    'sync',
  ],
  components: { RuiButton },
  props: {
    /* eslint-disable vue/require-prop-types */
    trusted: { required: false, default: null },
    current: { required: false, default: null },
    /* eslint-enable vue/require-prop-types */
    field: { required: true, type: String },
    disabled: { required: false, type: Boolean, default: false },
    message: { required: false, type: String, default: null },
  },
  computed: {
    syncable () { return !this.message && !isEqual(this.$props.current, this.$props.trusted) },
  },
}
</script>
